package com.company.test.view.a;

import com.company.test.entity.A;
import com.company.test.entity.B;
import com.company.test.view.b.BDetailView;
import com.company.test.view.main.MainView;
import com.vaadin.flow.router.Route;
import io.jmix.flowui.DialogWindows;
import io.jmix.flowui.kit.action.ActionPerformedEvent;
import io.jmix.flowui.model.CollectionPropertyContainer;
import io.jmix.flowui.model.DataContext;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

@Route(value = "as/:id", layout = MainView.class)
@ViewController(id = "A.detail")
@ViewDescriptor(path = "a-detail-view.xml")
@EditedEntityContainer("aDc")
public class ADetailView extends StandardDetailView<A> {
    @Autowired
    private DialogWindows dialogWindows;
    @ViewComponent
    private CollectionPropertyContainer<B> bDc;
    @ViewComponent
    private DataContext dataContext;

    @Subscribe("bDataGrid.createAction")
    public void onBDataGridCreateAction(final ActionPerformedEvent event) {
        dialogWindows.detail(this, B.class)
                .withViewClass(BDetailView.class)
                .withAfterCloseListener(closeEvent -> {
                    if (closeEvent.closedWith(StandardOutcome.SAVE)) {
                        B b = closeEvent.getView().getEditedEntity();
                        b.setA(getEditedEntity());
                        bDc.getMutableItems().add(b);
                    }
                })
//                .withInitializer(it -> it.setA(getEditedEntity()))
                .withParentDataContext(dataContext)
                .newEntity()
                .build()
                .open();
    }
}